import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/for_list.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';
import 'package:objd/wrappers/execute.dart';

class Ticker {
	static const String _scoreboardName = 'dabric_tickers';
	static final HashMap<int, Score> _tickers = HashMap();

	static Widget load() {
		addDelay(2);
		addDelay(5);
		addDelay(10);
		addDelay(20);

		return For.of([
			Scoreboard(_scoreboardName, addIntoLoad: false),
			..._tickers.values
		]);
	}

	static Widget tick() {
		List<Widget> actions = [];

		_tickers.forEach((k, v) {
			actions.addAll([
				Execute(If: Condition.score(v.matchesRange(Range(from: k))), children: [v.set(0)]),
				v.add(1)
			]);
		});

		return For.of([
			...actions
		]);
	}

	static void addDelay(int ticks) {
		_tickers.addEntries([MapEntry(ticks, Score(Entity.PlayerName('c${ticks}'), _scoreboardName, addNew: false).set(0))]);
	}

	static Condition delay(int ticks) {
		return Condition.score(_tickers[ticks].matchesRange(Range(from: ticks)));
	}
}
